#!/usr/bin/perl
#
# SmoothWall CGIs
#
# This code is distributed under the terms of the GPL
#
# (c) The SmoothWall Team
#
### 2007-0106 - netsetup.cgi v.0.1-test1 for NetSetup v.0.1 mod by catastrophe
# - Intended for use on Smoothwall Express 2.0 fixes9 ui-3.6.1
# - Support for the BLUE Interface mod by Daniel Hokka Zakrisson (daniel_hozac)
# - Added "page generated in 'x' seconds" (thanks daniel_hozac)
##
# Future plans:
# - Not sure. Let us know!
#
# - Disclaimer:
#    - Use at your own risk without any or implied warranty.
###

############
###HEADER###
############

require '/var/smoothwall/header.pl';

use Time::HiRes qw( gettimeofday );

###############
###VARIABLES###
###############

my (%netsetupsettings, %netsetupsettings2, %checked);


##########
###MENU###
##########

#&showhttpheaders();

$netsetupsettings{'ACTION'} = '';
$netsetupsettings{'NETSETUP_HIDE_ALERTBOX'} = 'on';		# ...gain more gui space...
$netsetupsettings{'NETSETUP_REFRESH'} = '0';			# 0=off, >0=on (in seconds)
$netsetupsettings{'NETSETUP_SHOW_PREFERENCES'} = 'of';
$netsetupsettings{'NETSETUP_SHOW_PREFERENCES2'} = 'of';
$netsetupsettings{'NETSETUP_SHOW_ETHERNET_SETTINGS'} = 'of';
$netsetupsettings{'NETSETUP_ETHERNET_SETTINGS_FILE'} = '/var/smoothwall/ethernet/settings';



#/*0*/   "GREEN (RED is modem/ISDN)",
#/*1*/   "GREEN + ORANGE (RED is modem/ISDN)",
#/*2*/   "GREEN + RED",
#/*3*/   "GREEN + ORANGE + RED",
#/*4*/   "GREEN + BLUE (RED is modem/ISDN)",
#/*5*/   "GREEN + BLUE + ORANGE (RED is modem/ISDN)",
#/*6*/   "GREEN + BLUE + RED",
#/*7*/   "GREEN + BLUE + ORANGE + RED",


$netsetupsettings2{'CONFIG_TYPE'} = '';

$netsetupsettings2{'GREEN_DEV'} = '';
$netsetupsettings2{'GREEN_DRIVER'} = '';
$netsetupsettings2{'GREEN_DRIVER_OPTIONS'} = '';
$netsetupsettings2{'GREEN_DISPLAYDRIVER'} = '';
$netsetupsettings2{'GREEN_ADDRESS'} = '';
$netsetupsettings2{'GREEN_NETMASK'} = '';
$netsetupsettings2{'GREEN_NETADDRESS'} = '';
$netsetupsettings2{'GREEN_BROADCAST'} = '';

$netsetupsettings2{'ORANGE_DEV'} = '';
$netsetupsettings2{'ORANGE_DRIVER'} = '';
$netsetupsettings2{'ORANGE_DRIVER_OPTIONS'} = '';
$netsetupsettings2{'ORANGE_DISPLAYDRIVER'} = '';
$netsetupsettings2{'ORANGE_ADDRESS'} = '';
$netsetupsettings2{'ORANGE_NETMASK'} = '';
$netsetupsettings2{'ORANGE_NETADDRESS'} = '';
$netsetupsettings2{'ORANGE_BROADCAST'} = '';

$netsetupsettings2{'RED_DEV'} = '';
$netsetupsettings2{'RED_DRIVER'} = '';
$netsetupsettings2{'RED_DRIVER_OPTIONS'} = '';
$netsetupsettings2{'RED_DISPLAYDRIVER'} = '';
$netsetupsettings2{'RED_DHCP_HOSTNAME'} = '';
$netsetupsettings2{'RED_ADDRESS'} = '';
$netsetupsettings2{'RED_NETMASK'} = '';
$netsetupsettings2{'RED_TYPE'} = '';
$netsetupsettings2{'RED_NETADDRESS'} = '';
$netsetupsettings2{'RED_BROADCAST'} = '';
$netsetupsettings2{'DNS1'} = '';
$netsetupsettings2{'DNS2'} = '';
$netsetupsettings2{'DEFAULT_GATEWAY'} = '';

$netsetupsettings2{'BLUE_DEV'} = '';
$netsetupsettings2{'BLUE_DRIVER'} = '';
$netsetupsettings2{'BLUE_DRIVER_OPTIONS'} = '';
$netsetupsettings2{'BLUE_DISPLAYDRIVER'} = '';
$netsetupsettings2{'BLUE_ADDRESS'} = '';
$netsetupsettings2{'BLUE_NETMASK'} = '';
$netsetupsettings2{'BLUE_NETADDRESS'} = '';
$netsetupsettings2{'BLUE_BROADCAST'} = '';
$netsetupsettings2{'BLUE_TYPE'} = '';

&getcgihash(\%netsetupsettings);


my $errormessage = '';

if ($netsetupsettings{'ACTION'} eq Save)
{

$netsetupsettings2{'CONFIG_TYPE'} = $netsetupsettings{'CONFIG_TYPE'};
delete $netsetupsettings{'CONFIG_TYPE'};
$netsetupsettings2{'GREEN_DEV'} = $netsetupsettings{'GREEN_DEV'};
delete $netsetupsettings{'GREEN_DEV'};
$netsetupsettings2{'GREEN_DRIVER'} = $netsetupsettings{'GREEN_DRIVER'};
delete $netsetupsettings{'GREEN_DRIVER'};
$netsetupsettings2{'GREEN_DRIVER_OPTIONS'} = $netsetupsettings{'GREEN_DRIVER_OPTIONS'};
delete $netsetupsettings{'GREEN_DRIVER_OPTIONS'};
$netsetupsettings2{'GREEN_DISPLAYDRIVER'} = $netsetupsettings{'GREEN_DISPLAYDRIVER'};
delete $netsetupsettings{'GREEN_DISPLAYDRIVER'};
$netsetupsettings2{'GREEN_ADDRESS'} = $netsetupsettings{'GREEN_ADDRESS'};
delete $netsetupsettings{'GREEN_ADDRESS'};
$netsetupsettings2{'GREEN_NETMASK'} = $netsetupsettings{'GREEN_NETMASK'};
delete $netsetupsettings{'GREEN_NETMASK'};
$netsetupsettings2{'GREEN_NETADDRESS'} = $netsetupsettings{'GREEN_NETADDRESS'};
delete $netsetupsettings{'GREEN_NETADDRESS'};
$netsetupsettings2{'GREEN_BROADCAST'} = $netsetupsettings{'GREEN_BROADCAST'};
delete $netsetupsettings{'GREEN_BROADCAST'};

$netsetupsettings2{'ORANGE_DEV'} = $netsetupsettings{'ORANGE_DEV'};
delete $netsetupsettings{'ORANGE_DEV'};
$netsetupsettings2{'ORANGE_DRIVER'} = $netsetupsettings{'ORANGE_DRIVER'};
delete $netsetupsettings{'ORANGE_DRIVER'};
$netsetupsettings2{'ORANGE_DRIVER_OPTIONS'} = $netsetupsettings{'ORANGE_DRIVER_OPTIONS'};
delete $netsetupsettings{'ORANGE_DRIVER_OPTIONS'};
$netsetupsettings2{'ORANGE_DISPLAYDRIVER'} = $netsetupsettings{'ORANGE_DISPLAYDRIVER'};
delete $netsetupsettings{'ORANGE_DISPLAYDRIVER'};
$netsetupsettings2{'ORANGE_ADDRESS'} = $netsetupsettings{'ORANGE_ADDRESS'};
delete $netsetupsettings{'ORANGE_ADDRESS'};
$netsetupsettings2{'ORANGE_NETMASK'} = $netsetupsettings{'ORANGE_NETMASK'};
delete $netsetupsettings{'ORANGE_NETMASK'};
$netsetupsettings2{'ORANGE_NETADDRESS'} = $netsetupsettings{'ORANGE_NETADDRESS'};
delete $netsetupsettings{'ORANGE_NETADDRESS'};
$netsetupsettings2{'ORANGE_BROADCAST'} = $netsetupsettings{'ORANGE_BROADCAST'};
delete $netsetupsettings{'ORANGE_BROADCAST'};


$netsetupsettings2{'RED_DEV'} = $netsetupsettings{'RED_DEV'};
delete $netsetupsettings{'RED_DEV'};
$netsetupsettings2{'RED_DRIVER'} = $netsetupsettings{'RED_DRIVER'};
delete $netsetupsettings{'RED_DRIVER'};
$netsetupsettings2{'RED_DRIVER_OPTIONS'} = $netsetupsettings{'RED_DRIVER_OPTIONS'};
delete $netsetupsettings{'RED_DRIVER_OPTIONS'};
$netsetupsettings2{'RED_DISPLAYDRIVER'} = $netsetupsettings{'RED_DISPLAYDRIVER'};
delete $netsetupsettings{'RED_DISPLAYDRIVER'};
$netsetupsettings2{'RED_DHCP_HOSTNAME'} = $netsetupsettings{'RED_DHCP_HOSTNAME'};
delete $netsetupsettings{'RED_DHCP_HOSTNAME'};
$netsetupsettings2{'RED_ADDRESS'} = $netsetupsettings{'RED_ADDRESS'};
delete $netsetupsettings{'RED_ADDRESS'};
$netsetupsettings2{'RED_NETMASK'} = $netsetupsettings{'RED_NETMASK'};
delete $netsetupsettings{'RED_NETMASK'};
$netsetupsettings2{'RED_TYPE'} = $netsetupsettings{'RED_TYPE'};
delete $netsetupsettings{'RED_TYPE'};
$netsetupsettings2{'RED_NETADDRESS'} = $netsetupsettings{'RED_NETADDRESS'};
delete $netsetupsettings{'RED_NETADDRESS'};
$netsetupsettings2{'RED_BROADCAST'} = $netsetupsettings{'RED_BROADCAST'};
delete $netsetupsettings{'RED_BROADCAST'};
$netsetupsettings2{'DNS1'} = $netsetupsettings{'DNS1'};
delete $netsetupsettings{'DNS1'};
$netsetupsettings2{'DNS2'} = $netsetupsettings{'DNS2'};
delete $netsetupsettings{'DNS2'};
$netsetupsettings2{'DEFAULT_GATEWAY'} = $netsetupsettings{'DEFAULT_GATEWAY'};
delete $netsetupsettings{'DEFAULT_GATEWAY'};

$netsetupsettings2{'BLUE_DEV'} = $netsetupsettings{'BLUE_DEV'};
delete $netsetupsettings{'BLUE_DEV'};
$netsetupsettings2{'BLUE_DRIVER'} = $netsetupsettings{'BLUE_DRIVER'};
delete $netsetupsettings{'BLUE_DRIVER'};
$netsetupsettings2{'BLUE_DRIVER_OPTIONS'} = $netsetupsettings{'BLUE_DRIVER_OPTIONS'};
delete $netsetupsettings{'BLUE_DRIVER_OPTIONS'};
$netsetupsettings2{'BLUE_DISPLAYDRIVER'} = $netsetupsettings{'BLUE_DISPLAYDRIVER'};
delete $netsetupsettings{'BLUE_DISPLAYDRIVER'};
$netsetupsettings2{'BLUE_ADDRESS'} = $netsetupsettings{'BLUE_ADDRESS'};
delete $netsetupsettings{'BLUE_ADDRESS'};
$netsetupsettings2{'BLUE_NETMASK'} = $netsetupsettings{'BLUE_NETMASK'};
delete $netsetupsettings{'BLUE_NETMASK'};
$netsetupsettings2{'BLUE_NETADDRESS'} = $netsetupsettings{'BLUE_NETADDRESS'};
delete $netsetupsettings{'BLUE_NETADDRESS'};
$netsetupsettings2{'BLUE_BROADCAST'} = $netsetupsettings{'BLUE_BROADCAST'};
delete $netsetupsettings{'BLUE_BROADCAST'};
$netsetupsettings2{'BLUE_TYPE'} = $netsetupsettings{'BLUE_TYPE'};
delete $netsetupsettings{'BLUE_TYPE'};

	&writehash("${swroot}/preferences/netsetup2", \%netsetupsettings2);
	system ("/bin/sort ${swroot}/preferences/netsetup2 -o ${swroot}/preferences/netsetup2");
	system ("${swroot}/mods/netsetup/modfiles/netsetuphelper");

	&writehash("${swroot}/preferences/netsetup", \%netsetupsettings);
	system ("/bin/sort ${swroot}/preferences/netsetup -o ${swroot}/preferences/netsetup");

}


system ("/bin/touch ${swroot}/preferences/netsetup");
&readhash("${swroot}/preferences/netsetup", \%netsetupsettings);

system ("/bin/touch ${swroot}/preferences/netsetup2");
&readhash("/var/smoothwall/ethernet/settings", \%netsetupsettings2);



&netsetupREFRESHset();



#&openpage('netsetup', 1, '', 'networking');

&shownetworkingsection();

&openbigbox('100%', 'LEFT');

if ($netsetupsettings{'NETSETUP_HIDE_ALERTBOX'} eq 'on') {
	###then do nothing
} else {
	&alertbox($errormessage);
}



print "<FORM METHOD='POST'>\n";
#&openbox('100%', 'LEFT');
&openbox('100%', 'LEFT', 'Ethernet Settings: ');

&netsetupDISPLAYmenu();

print "</FORM>\n";
&closebox();

##########
###MAIN###
##########

&netsetupDISPLAYmain();

&closebigbox();
&closepage();

$t1 = gettimeofday(); $t2=$t1-$t0;
print "<PRE><center>Page generated in ", sprintf ('%.2f', $t2), " seconds.</center></PRE>";

##########
###DONE###
##########





#################
###SUBROUTINES###
#################


sub netsetupREFRESHset {
	my $refresh = $netsetupsettings{'NETSETUP_REFRESH'};
	if ($refresh > 0)
	{
		print "Refresh: $refresh\n";
		print "Cache-Control: no-cache\n";
		print "Pragma: no-cache\n";
	}
	&showhttpheaders();
	$t0 = gettimeofday();
#	&openpage('netsetup', 1, '', 'networking');
	&openpage('Simple wireless access point configuration', 1, '', 'networking');
}



sub netsetupDISPLAYmenu {

print "<table width='100%' border='0' cellspacing='0' cellpadding='0'>";
print "<TR>";



print "<TD align='right' width='50%'>";
print "Configuration Type: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='CONFIG_TYPE' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'CONFIG_TYPE'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Green Device: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='GREEN_DEV' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'GREEN_DEV'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Green Driver: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='GREEN_DRIVER' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'GREEN_DRIVER'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Green Driver Options: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='GREEN_DRIVER_OPTIONS' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'GREEN_DRIVER_OPTIONS'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Green Display Driver: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='GREEN_DISPLAYDRIVER' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'GREEN_DISPLAYDRIVER'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Green Address: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='GREEN_ADDRESS' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'GREEN_ADDRESS'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Green Netmask: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='GREEN_NETMASK' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'GREEN_NETMASK'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Green Netaddress: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='GREEN_NETADDRESS' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'GREEN_NETADDRESS'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Green Broadcast: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='GREEN_BROADCAST' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'GREEN_BROADCAST'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Orange Device: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='ORANGE_DEV' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'ORANGE_DEV'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Orange Driver: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='ORANGE_DRIVER' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'ORANGE_DRIVER'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Orange Driver Options: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='ORANGE_DRIVER_OPTIONS' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'ORANGE_DRIVER_OPTIONS'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Orange Display Driver: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='ORANGE_DISPLAYDRIVER' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'ORANGE_DISPLAYDRIVER'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Orange Address: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='ORANGE_ADDRESS' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'ORANGE_ADDRESS'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Orange Netmask: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='ORANGE_NETMASK' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'ORANGE_NETMASK'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Orange Netaddress: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='ORANGE_NETADDRESS' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'ORANGE_NETADDRESS'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Orange Broadcast: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='ORANGE_BROADCAST' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'ORANGE_BROADCAST'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Red Device: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='RED_DEV' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'RED_DEV'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Red Driver: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='RED_DRIVER' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'RED_DRIVER'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Red Driver Options: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='RED_DRIVER_OPTIONS' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'RED_DRIVER_OPTIONS'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Red Display Driver: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='RED_DISPLAYDRIVER' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'RED_DISPLAYDRIVER'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Red DHCP Hostname: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='RED_DHCP_HOSTNAME' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'RED_DHCP_HOSTNAME'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Red Address: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='RED_ADDRESS' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'RED_ADDRESS'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Red Netmask: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='RED_NETMASK' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'RED_NETMASK'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Red Type: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='RED_TYPE' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'RED_TYPE'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Red Netaddress: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='RED_NETADDRESS' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'RED_NETADDRESS'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Red Broadcast: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='RED_BROADCAST' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'RED_BROADCAST'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Default Gateway: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='DEFAULT_GATEWAY' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'DEFAULT_GATEWAY'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "DNS1: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='DNS1' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'DNS1'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "DNS2: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='DNS2' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'DNS2'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Blue Device: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='BLUE_DEV' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'BLUE_DEV'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Blue Driver: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='BLUE_DRIVER' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'BLUE_DRIVER'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Blue Driver Options: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='BLUE_DRIVER_OPTIONS' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'BLUE_DRIVER_OPTIONS'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Blue Display Driver: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='BLUE_DISPLAYDRIVER' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'BLUE_DISPLAYDRIVER'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Blue Address: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='BLUE_ADDRESS' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'BLUE_ADDRESS'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Blue Netmask: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='BLUE_NETMASK' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'BLUE_NETMASK'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Blue Netaddress: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='BLUE_NETADDRESS' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'BLUE_NETADDRESS'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Blue Broadcast: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='BLUE_BROADCAST' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'BLUE_BROADCAST'}'>";
print "</TD>";
print "</TR>";

print "<TR>";
print "<TD align='right' width='50%'>";
print "Blue Type: ";
print "&nbsp;&nbsp;";
print "</TD><TD>";
print "<INPUT TYPE='text' NAME='BLUE_TYPE' SIZE=16 MAXLENGTH=15 VALUE='$netsetupsettings2{'BLUE_TYPE'}'>";
print "</TD>";











print "</tr></table>";
#&closebox;

























#&openbox('100%', 'LEFT', '');

print qq|
<DIV ALIGN='CENTER'>
<table width='100%' border='0' cellspacing='0' cellpadding='0'>
<tr><br><br></tr>
<TR>
	<TD ALIGN='CENTER'><INPUT TYPE='submit' NAME='ACTION' VALUE='$tr{'save'}'></TD> 
</TR>
</TABLE>
</DIV>
|;
##&closebox();



}








sub netsetupDISPLAYmain {

if ($netsetupsettings{'NETSETUP_SHOW_PREFERENCES'} eq 'on') {
	&openbox('100%', 'LEFT', 'Preferences: ');
	print "<PRE>";
	system ('cat', '/var/smoothwall/preferences/netsetup');
	print "</PRE>\n";
	&closebox();
}


if ($netsetupsettings{'NETSETUP_SHOW_PREFERENCES2'} eq 'on') {
	&openbox('100%', 'LEFT', 'Preferences2: ');
	print "<PRE>";
	system ('cat', '/var/smoothwall/preferences/netsetup2');
	print "</PRE>\n";
	&closebox();
}

if ($netsetupsettings{'NETSETUP_SHOW_ETHERNET_SETTINGS'} eq 'on') {
	&openbox('100%', 'LEFT', 'Ethernet Settings: ');
	print "<PRE>";
	system ('cat', '/var/smoothwall/ethernet/settings');
	print "</PRE>\n";
	&closebox();
}




}
